#include <string.h>
#include <stdio.h>

#include <switch.h>

//Define some used variables.
int v_frame = 0;
int v_switch = 0;
int v_waittime_init = 60;
int v_waittime;
bool v_angry = 0;
int v_angrytimes = 0;
int v_i;
int v_i2;

void swiWaitForVBlank() {
	consoleUpdate(NULL);
}
	
int main(void) {
	//Shorthand as in examples.
	//Is this going to be a bad habit?
	hidInitializeTouchScreen();

	//Initialize console. Using NULL as the second argument tells the console library to use the internal console structure as current one.
	consoleInit(NULL);
	
	padConfigureInput(1, HidNpadStyleSet_NpadStandard);
	PadState pad;
    padInitializeDefault(&pad);
	
	//Copy the initial value over to the real one.
	//Makes debugging easier so I can adjust timing.
	v_waittime = v_waittime_init;
	
	consoleClear();
	printf("\x1b[1;32HUseless Homebrew!");
	printf("\x1b[22;40H / ");
	printf("\x1b[45;35HSWITCH: \x1b[31mOFF\x1b[39m");
 
	while(1) {
		v_frame++;
		//Manual timing is witchcraft. :P
		swiWaitForVBlank();
		padUpdate(&pad);

		//hidKeysDown returns information about which buttons have been just pressed (and they weren't in the previous frame)
		u64 kDown = padGetButtonsDown(&pad);
		
		//Grab current position of stylus/finger/penis (DON'T JUDGE ME!!!)
		HidTouchScreenState state={0};
		int touchpx = 0, touchpy = 0;
		
		if (hidGetTouchScreenStates(&state, 1)) {
			touchpx = state.touches[0].x;
			touchpy = state.touches[0].y;
		}
		
		
		//Assuming anger has not yet been set off... We want to run
		//through the standard flipping/displaying loop.
		if (v_angry == 0) {
			
			if (kDown & HidNpadButton_Plus) break;
			
			//Check stylus position compared to the switch (if the switch is off)
			if (((touchpx > 38*16 && touchpx < 42*16 && touchpy > 20*16 && touchpy < 24*16 && v_switch == 0)/* && touch_count > 0*/) || kDown & HidNpadButton_A) {
				//Correct?  Okay, flip the switch.
				v_switch = 1;
				//Also reset the frame counter.
				v_frame = 0;
				
				consoleClear();
				printf("\x1b[1;32HUseless Homebrew!");
				printf("\x1b[22;40H\\ ");
				printf("\x1b[45;35HSWITCH: \x1b[32mON!\x1b[39m");
			}
			
			//If enough time has passed, flip the switch back on and reduce the wait.
			if (v_switch == 1 && v_frame == v_waittime) {
				v_switch = 0;
				v_waittime = v_waittime - (v_waittime / 3);
				
				consoleClear();
				printf("\x1b[1;32HUseless Homebrew!");
				printf("\x1b[22;40H / ");
				printf("\x1b[45;35HSWITCH: \x1b[31mOFF\x1b[39m");
			}
			
			//If the count is below a certain level (so the user has flipped the switch
			//too many times), get angry.
			if (v_switch == 1 && v_waittime < 10) {
				v_angry = 1;
			}
			
		//Okay, if anger has been set off...
		} else {
			
			//How many times have you gotten mad?
			switch (v_angrytimes) {
			//First time?
			case 0:
				consoleClear();
				swiWaitForVBlank();
				//Angry ASCII.
				printf("\n\n\n     ------------\n    /            \\\n   /              \\\n  /      \\    /    \\    STOP\n /        \\  /      \\   DOING\n|        # \\/ #      |  THAT!\n|                    |\n|                    |\n|                    |\n|         ____       |\n|        /    \\      |\n|       /      \\     |\n \\     /________\\   /\n  \\                /\n   \\              /\n    \\____________/");
				//Wait two seconds.
				for(v_i = 1; v_i < 120; v_i++) {
					swiWaitForVBlank();
				}
				//Un-anger, switch back off, reset waittime.
				v_angry = 0;
				v_switch = 0;
				v_waittime = v_waittime_init;
				
				consoleClear();
				printf("\x1b[1;32HUseless Homebrew!");
				printf("\x1b[22;40H / ");
				printf("\x1b[45;35HSWITCH: \x1b[31mOFF\x1b[39m");
				break;
			
			case 1:
				consoleClear();
				swiWaitForVBlank();
				//A threat, eh?
				printf("\x1b[11;6HFine, have a seizure!");
				//Wait a second or so for the user to read it.
				for(v_i = 1; v_i < 80; v_i++) {
					swiWaitForVBlank();
				}
				consoleClear();
				
				//Loop that writes a bunch of red, green, then blue
				//8's on the screen repeatedly.  Only does it a few
				//times and waits 2 frames each write because I
				//don't intend to actually cause a seizue...
				for(v_i2 = 1; v_i2 < 7; v_i2++) {
					for(v_i = 1; v_i <= 45; v_i++) {
						printf("\x1b[32m88888888888888888888888888888888888888888888888888888888888888888888888888888888");
					}
					for(v_i = 1; v_i < 10; v_i++) { swiWaitForVBlank(); }
					consoleClear();
					
					for(v_i = 1; v_i <= 45; v_i++) {
						printf("\x1b[31m88888888888888888888888888888888888888888888888888888888888888888888888888888888");
					}
					for(v_i = 1; v_i < 10; v_i++) { swiWaitForVBlank(); }
					consoleClear();
					
					for(v_i = 1; v_i <= 45; v_i++) {
						printf("\x1b[34m88888888888888888888888888888888888888888888888888888888888888888888888888888888");
					}
					for(v_i = 1; v_i < 10; v_i++) { swiWaitForVBlank(); }
					consoleClear();
				}
				//Un-anger, switch back off, reset waittime.
				v_angry = 0;
				v_switch = 0;
				v_waittime = v_waittime_init;
				
				consoleClear();
				printf("\x1b[1;32H\x1B[37mUseless Homebrew!");
				printf("\x1b[22;40H / ");
				printf("\x1b[45;35HSWITCH: \x1b[31mOFF\x1b[39m");
				break;
			
			case 2:
				consoleClear();
				//Warning.
				printf("\n\n\n\n          That's it!");
				printf("\n   I'm formatting your NAND!\n");
				for(v_i = 1; v_i < 120; v_i++) { swiWaitForVBlank(); }
				//Pretend to delete imaginary files from an imaginary place, then pause a second.
				printf("\nn0:\\NVIDIA\\tegra.bin Deleted");
				for(v_i = 1; v_i < 30; v_i++) { swiWaitForVBlank(); }
				printf("\nn0:\\hid.bin Deleted");
				for(v_i = 1; v_i < 30; v_i++) { swiWaitForVBlank(); }
				printf("\nn0:\\fs\\fat.h Deleted");
				for(v_i = 1; v_i < 30; v_i++) { swiWaitForVBlank(); }
				printf("\nn0:\\wifi.bin Deleted");
				for(v_i = 1; v_i < 30; v_i++) { swiWaitForVBlank(); }
				printf("\nn0:\\fs\\nitrofs.h Deleted");
				for(v_i = 1; v_i < 30; v_i++) { swiWaitForVBlank(); }
				printf("\nn0:\\audio.h Deleted");
				for(v_i = 1; v_i < 30; v_i++) { swiWaitForVBlank(); }
				printf("\nn0:\\keys\\Switch.bin Deleted");
				for(v_i = 1; v_i < 30; v_i++) { swiWaitForVBlank(); }
				printf("\nn0:\\keys\\NX.bin Deleted");
				for(v_i = 1; v_i < 30; v_i++) { swiWaitForVBlank(); }
				printf("\nn0:\\keys\\STAGE_2.bin Deleted");
				for(v_i = 1; v_i < 30; v_i++) { swiWaitForVBlank(); }
				printf("\nn0:\\system32\\* Deleted");
				for(v_i = 1; v_i < 30; v_i++) { swiWaitForVBlank(); }
				printf("\nn0:\\girl_boobies.jpg Deleted");
				for(v_i = 1; v_i < 60; v_i++) { swiWaitForVBlank(); }
				//Goodbye message, then a longer pause.
				printf("\n\nBye. :)");
				for(v_i = 1; v_i < 120; v_i++) { swiWaitForVBlank(); }
				//Shut the user's system off. Idk if there is a command for the switch
				//and having to run the exploit each time you played again would be a
				//pain in the ass. So no shutdown for us!
				//systemShutDown();
				consoleClear();
				break;
			}
			//Anger plus one.
			v_angrytimes++;
			
		}
		
	}
	consoleExit(NULL);
	return 0;
}